#include <stdlib.h>
#include <stdio.h>
#include "ingrediente.h"
#include "string.h"

IngredienteList ingredienteEmptyList()
{
	return NULL;
}

Boolean isIngredienteListEmpty(IngredienteList list)
{
	return list == NULL;
}

IngredienteList addIngrediente(IngredienteList list, Ingrediente ing)
{
	IngredienteList newHead = (IngredienteList)malloc(
		sizeof(IngredienteListElement));
	newHead->valore = ing;
	newHead->next = list;
	return newHead;
}

Ingrediente headList(IngredienteList list)
{
	if (!isIngredienteListEmpty(list))
	{
		return list->valore;
	}
	else
	{
		abort();
	}
}

IngredienteList ingredienteListTail(IngredienteList list)
{
	if (!isIngredienteListEmpty(list))
	{
		return list->next;
	}
	else
	{
		abort();
	}
}

Boolean readIngredienteFromTxt(FILE *f, Ingrediente *ing)
{
	Boolean ok;
	ok = fscanf(f, "%s", ing->nome) == 1;
	ok = ok && fscanf(f, "%f", &ing->prezzo) == 1;
	fgetc(f);
	return ok;
}

IngredienteList readIngredienti(char fileName[])
{
	FILE *f;
	Ingrediente ing;
	IngredienteList list = ingredienteEmptyList();

	f = fopen(fileName, "r");
	if (f == NULL)
	{
		return list;
	}

	while (readIngredienteFromTxt(f, &ing))
	{
		list = addIngrediente(list, ing);
	}

	fclose(f);
	return list;
}

void printIngredienti(IngredienteList list)
{
	while (!isIngredienteListEmpty(list))
	{
		Ingrediente ing = headList(list);
		printf("%s -- %.2hfE\n", ing.nome, ing.prezzo);
		list = ingredienteListTail(list);
	}
	printf("\n");
}

float trovaPrezzo(IngredienteList list, char nome[])
{
	while (!isIngredienteListEmpty(list))
	{
		if (strcmp(headList(list).nome, nome) == 0)
		{
			return headList(list).prezzo;
		}
		list = ingredienteListTail(list);
	}
	return -1;
}

void aggiornaPrezzo(IngredienteList list, char nome[], float prezzo)
{
	Boolean trovato = false;
	while (!isIngredienteListEmpty(list) && !trovato)
	{
		if (strcmp(headList(list).nome, nome) == 0)
		{
			list->valore.prezzo = prezzo;
			trovato = true;
		}
		list = ingredienteListTail(list);
	}
}

